unit Unit0050;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    FontDialog1: TFontDialog;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
    procedure G_CIRC(C:TCanvas;rx1,ry1,rr1:Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ʂNA
procedure TForm1.G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
begin
   with C do begin
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(x1,y1,x2,y2);
   end;
end;

// ԁ`
procedure TForm1.G_CIRC(C:TCanvas;rx1,ry1,rr1:Integer);
begin
   with C do begin
      Pen.Mode := pmCopy ;
      Pen.Color := clRed ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Color := clRed ;
      Brush.Style := bsSolid ;
      Ellipse(rx1-rr1,ry1-rr1,rx1+rr1,ry1+rr1);
   end;
end;



// tHg
procedure TForm1.Button1Click(Sender: TObject);
begin
   FontDialog1.Execute ;
end;

// `
procedure TForm1.Button2Click(Sender: TObject);
var
   LogFont : TLogFont ;
   d : double ;
   i : integer ;
   ia,iz,iw,ii,iu,it,ic,ix,iy : integer ;
   fo : String ;
begin
   G_CLS(Image1.Canvas,0,0,Image1.Width,Image1.Height) ;
   if (Edit1.Text = '') then exit ;

   val(Edit2.Text,d,i);
   if (i <> 0) then exit ;
   ia := Round(d*10.0) ;
   iz := FontDialog1.Font.Size ;
   iw := FW_NORMAL ;
   if (fsBold in FontDialog1.Font.Style) then iw := FW_BOLD ;
   ii := 0 ;
   if (fsItalic in FontDialog1.Font.Style) then ii := 1 ;
   iu := 0 ;
   if (fsUnderline in FontDialog1.Font.Style) then iu := 1 ;
   it := 0 ;
   if (fsStrikeOut in FontDialog1.Font.Style) then it := 1 ;
   fo := FontDialog1.Font.Name ;
   ic := FontDialog1.Font.Color ;
   ix := Image1.Width div 2 ;
   iy := Image1.Height div 2 ;
   G_CIRC(Image1.Canvas,ix,iy,5);

   with LogFont do begin
      lfHeight := iz ;        // 
      lfWidth  := iz div 2 ;  // 
      lfEscapement := ia ;    // ]px[] 10{l
      lfOrientation := ia ;   // lfEscapementƓl
      lfWeight := iw ;        // w ʏ FW_NORMAL
      lfItalic := ii ;        // Α̎w L=1 =0
      lfUnderline := iu ;     // w L=1 =0
      lfStrikeOut := it ;     // w L=1 =0
      lfCharSet := DEFAULT_CHARSET ;
      lfOutPrecision := OUT_DEFAULT_PRECIS ;
      lfClipPrecision := CLIP_DEFAULT_PRECIS ;
      lfQuality := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName,fo);   // tHg
   end;
   with Image1.Canvas do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Font.Color := ic ;
      Brush.Style := bsClear ;
      TextOut(ix,iy,Edit1.Text);
   end;
end;

end.
